from mynum import *
from mypyx import *
import os

x = arange(8+1)
y = 10.0**(-x)
g = graph.graphxy(width=5, height=5,
                  x=graph.axis.lin(title=r"$\nu$"),
                  y=graph.axis.log(title=r"$e^{(\nu)}$"))
g.plot(datalist(x, y), [graph.style.symbol(graph.style.symbol.circle)])
g.plot(datalist(x, y), [graph.style.line()])
g.writetofile("ideal_convergence.eps")
os.system("epstopdf ideal_convergence.eps")

