from numpy import *

import multigrid as mg

def residual_1d(x, A, b):
    # create y
    return y
            
def jac_1d(x, A, b):
    # create y
    return y
            
def lex_gs_1d(x, A, b):
    # create y
    return y

def rb_gs_1d(x, A, b):
    # create y
    return y

def fwr_1d(x):
    # create y
    return y

def li_1d(x):
    n = len(x) - 1
    y = zeros(2*n+1)
    y[::2] = x
    y[1:-1:2] = (x[:-1] + x[1:]) / 2.0
    return y

# u_xx + f = 0
if __name__ == "__main__":
    nlevels = 4
    nit = 10
    n_ = 2
    n = n_ * 2**(nlevels-1)
    h = 1.0 / n
    x = arange(n+1) * h
    #u_exact = ones(n+1)
    #f = zeros(n+1)
    u_exact = x**2
    f  = -2 + 0*x
    #u_exact = x**4
    #f  = -3*4*x**2
    # A ~ -u_xx
    # b ~ f
    L = []
    h_ = 1.0 / n_
    for level in range(nlevels):
        L.append(h)
        h_ /= 2
    u = u_exact.copy()
    u[1:-1] = 0
    smoother = mg.weighted_relaxation(2.0/3.0, jac_1d)
    #smoother = lex_gs_1d
    #smoother = rb_gs_1d
    tol = 1e-15
    #r = residual_1d(u_exact, L[-1], f)
    #print "r", r
    #print "u", u
    #print "f", f
    #r = residual_1d(u, L[-1], f)
    #print "r", r
    norm = mg.maxabs
    def resfun(u):
        return residual_1d(u, L[-1], f)
    def itfun(u):
        return mg.mg(nlevels-1, u, L, f, 
                     smoother, residual_1d, fwr_1d, li_1d, rb_gs_1d, "V")
    mg.report_iteration(u, itfun, nit, tol, resfun, u_exact, norm)
