from pyx import *

u = 1.0

def draw_grid(c, n, s, p=(0,0)):
    d = map(lambda x, y: x / y, s, n)
    x = p[0]
    for i in range(n[0]+1):
        pth = path.line(x, p[1], x, p[1] + s[1])
        c.stroke(pth)
        x += d[0]
    y = p[1]
    for j in range(n[1]+1):
        pth = path.line(p[0], y, p[0] + s[0], y)
        c.stroke(pth)
        y += d[1]
            
c = canvas.canvas()
x, y = 0, 0
for i in range(4, 0, -1):
    draw_grid(c, (2**i, 2**i), (u, u), (x, y))
    x += u * 1.1
c.writetofile("grids.eps")

